import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.IOException;
import com.nokia.mid.ui.FullCanvas;
import java.util.*;


class TestCanvas
    extends FullCanvas
    implements Runnable, CommandListener
{
    private volatile Thread animationThread = null;
    private static final int MILLIS_PER_TICK = 500;  
    private Font bigfont, font, smallfont;
    private Image map,map2;
    private int   rcenterx[], rcentery[], owner[], continent[], army[];
    private int   conn1[], conn2[], all_conns;
    private char  maptx[];
    private static final int REGIONS=64, CONNECTIONS=256, MINIMAL_COUNTRY_SIZE=64, PLAYERS=4, STARTING_ARMY=3, ARMYLIMIT=9;
    private char  mapR[]={ 255, 255,   0, 255, 180, 64, 255};
    private char  mapG[]={   0, 255, 255, 128, 180, 64, 255};
    private char  mapB[]={   0,   0,   0,   0, 180, 64, 255};
    private char  mode=0, backmode=0, menupos=0, mappos=0, mapfrom=0;
    private int   soldiers=0, lost_soldiers=0;
    private int   anicnt=0;
    String msg1,msg2,msg3,msg4;


    TestCanvas(testMIDlet papa)
    {
    }

    private int sqrt(int s)
    {
        int i;

        for( i=0; i<1000; i++) {
	    if (i*i>s) return i;
	}

	return -1;
    }

    private void box( Graphics g, int x0, int y0, int dx, int dy, String txt)
    {
        int i,j;

        g.setColor( 160, 160, 160);
        g.fillRect( x0,y0,dx,dy);
//        g.setColor( 0, 0, 64);
//        g.Rect( x0,y0-12,dx,12);
	for( i=0; i<dx; i++) {
	    j=6*i; if (j>255) j=255;
	    g.setColor(i,i,j);
	    g.drawLine( x0+i, y0-12, x0+i,y0);
	}
	g.setFont (smallfont);
        g.setColor( 255,255,255);
	g.drawString( txt, x0+2, y0-10, 0);
        g.drawRect( x0,y0,dx,dy);
    }

    private void editbox( Graphics g, int x0, int y0, int dx, int dy, String txt)
    {
        g.setColor( 255, 255, 255);
        g.fillRect( x0,y0,dx,dy);
        g.setColor(  90,  90, 90);
	g.drawLine(  x0,  y0, x0+dx,y0);
	g.drawLine(  x0,  y0, x0,y0+dy);
        g.setColor( 190, 190, 190);
	g.drawLine( x0+dx,y0+dy,x0+dx,y0);
	g.drawLine( x0,y0+dy,x0+dx,y0+dy);
	g.setFont (smallfont);
        g.setColor( 0, 0, 0);
	g.drawString( txt, x0+4,y0+3, 0);
    }

    private void button( Graphics g, int x0, int y0, int dx, int dy, String txt)
    {
        g.setColor( 160, 160, 160);
        g.fillRect( x0,y0,dx,dy);
        g.setColor( 190, 190,190);
	g.drawLine(  x0,  y0, x0+dx,y0);
	g.drawLine(  x0,  y0, x0,y0+dy);
        g.setColor(  90,  90, 90);
	g.drawLine( x0+dx,y0+dy,x0+dx,y0);
	g.drawLine( x0,y0+dy,x0+dx,y0+dy);
	g.setFont (smallfont);
        g.setColor( 0, 0, 0);
	g.drawString( txt, x0+4,y0+2, 0);
    }

    private void buttonup( Graphics g, int x0, int y0, int way)
    {
	int i;

	button( g, x0, y0, 10, 7, "");
	for( i=0; i<4; i++) 
	    switch (way) {
		case 0: g.drawLine(x0+5-i,y0+i+1,x0+5+i,y0+i+1); break;
		case 1: g.drawLine(x0+2+i,y0+i+1,x0+8-i,y0+i+1); break;
	    }
    }


    public void paint(Graphics g)
    {
        int width = getWidth();
        int height= getHeight();
	int j,k;

	if (mode==255) {
	    box( g,10,20,108,60,"Warning");
	    g.setColor(64,64,64);
	    g.drawString(msg1,16,26,0);
	    g.drawString(msg2,16,36,0);
	    g.drawString(msg3,16,46,0);
	    g.drawString(msg4,16,56,0);
	    g.setColor(255,255,255);
	    g.drawString(msg1,15,25,0);
	    g.drawString(msg2,15,35,0);
	    g.drawString(msg3,15,45,0);
	    g.drawString(msg4,15,55,0);
	    g.setColor( 60, 64, 60);
	    g.drawString("Press 5 to continue",17,70,0);
	    g.setColor( 160, 164, 160);
	    g.drawString("Press 5 to continue",16,69,0);
	    return;
	}

	if (mode==4) {
  	    box( g, 10,20,108,35, "How many soldiers?");
	    editbox( g, 50,30, 30,15, String.valueOf(soldiers));
	    buttonup( g, 81,30,0);
	    buttonup( g, 81,38,1);
	    return;
	}

	if (mode==6) {
	    box( g,20,32,77,87, "OPTIONS");
	    g.setColor( 128, 128,128);
	    g.fillRect( 25, 39+menupos*9, 67, 11);
	    g.setColor( 0, 0, 0);
	    g.drawString( "New game",  30, 40, 0 );
	    g.drawString( "Load game", 30, 49, 0 );
	    g.drawString( "Save game", 30, 58, 0 );
	    g.drawString( "Quit",      30, 67, 0 );
	    g.drawString( "---------", 30, 76, 0 );
	    g.drawString( "Players",   30, 85, 0 );
	    g.drawString( "Rules",     30, 94, 0 );
	    g.drawString( "Back",      30, 104, 0 );
	    return;
	}
        if ((mode==2)||(mode==3)) {
	    if (anicnt<1)
            	g.drawImage( map2, 0,0,0);
	    else
            	g.drawImage( map, 0,0,0);
	
	} else 
            g.drawImage( map, 0,0,0);
        g.setColor(0,0,0);
        g.fillRect(0,120,127,8);
	anicnt=(anicnt+1)%2;

	if (mode==0) {
	} else if (mode==1) { /* menu edit */
	    g.setColor(255,255,255);
	    g.setFont(smallfont);
	    if (menupos<0) menupos=2;
	    if (menupos>2) menupos=0;
	    switch (menupos) {
	       case 0: g.drawString( "Make move", 5, 120, 0); break;
	       case 1: g.drawString( "End turn", 5, 120, 0); break;
	       case 2: g.drawString( "Options", 5, 120, 0); break;
	    }
	} else if (mode==2) { /* Move - select from */
	    g.setColor(255,255,255);
	    g.setFont(smallfont);
	    g.drawString( "Select from", 5, 120, 0); 
	} else if (mode==3) { /* Move - select to */
	    g.setColor(255,255,255);
	    g.setFont(smallfont);      
	    g.drawString( "Select to", 5, 120, 0); 
	} else if (mode==5) { /* AI working... */
	    for( j=0; j<PLAYERS-1; j++) {
		if (j<=menupos)
		    g.setColor( mapR[j+2], mapG[j+2], mapB[j+2] );
		else 
		    g.setColor( 160, 160, 160 );
		g.fillRect( j*128/(PLAYERS-1),120, (j+1)*128/(PLAYERS-1), 127);
		g.setColor( 255,255,255 );
		g.drawRect( j*128/(PLAYERS-1),120, (j+1)*128/(PLAYERS-1), 127);
	    }
	} else if (mode==7) {
  	    box( g, 10,20,108,85, "New supplies");
	    g.setColor( 0,0,0 );
	    g.drawString("armies arrived.",25,55,0);
	    if (lost_soldiers>0) {
	        g.drawString("armies lost.",25,85,0);
	    }
	    g.setFont(bigfont);
	    g.setColor(  0, 0,128);
	    g.drawString(String.valueOf(soldiers-lost_soldiers),55,25,0);
	    g.setColor( 64,64, 96);
	    g.drawString(String.valueOf(soldiers-lost_soldiers),56,26,0);
	    if (lost_soldiers>0) {
	        g.setColor(  0, 0,128);
	        g.drawString(String.valueOf(lost_soldiers),55,65,0);
	        g.setColor( 64,64, 96);
	        g.drawString(String.valueOf(lost_soldiers),56,66,0);
	    }
	    g.setColor( 60, 60, 60);
	    g.setFont (smallfont);
	    g.drawString("Press 5 to continue",16,95,0);
	} else if (mode==8) {
  	    box( g, 10,20,108,65, "Victory");
	    g.setFont(bigfont);
	    g.setColor(  64,64,96);
	    g.drawString("You WIN!",16,31,0);
	    g.setColor(  0, 0,128);
	    g.drawString("You WIN!",15,30,0);
	} else if (mode==9) {
  	    box( g, 10,20,108,65, "Died...");
	    g.setFont(bigfont);
	    g.setColor(  64,64,96);
	    g.drawString("You loose...",16,31,0);
	    g.setColor(  0, 0,128);
	    g.drawString("You loose...",15,30,0);
	}

    }

    private void got_enter( int mpos)
    {
	int i;

	if ((mode==1)&&(mpos==0)) { /*MOVE*/
	    mode=2;
	    i=owner[mappos];
	    owner[mappos]=6;
	    draw_selected_map( map, map2, mappos);
	    owner[mappos]=i;
	} else if ((mode==1)&&(mpos==1)) {
	    mode=5; run_ai();
	} else if ((mode==1)&&(mpos==2)) {
	    mode=6; menupos=7; /* OPTIONS */
	} else if (mode==2) {
	    if (owner[mappos]!=1) {
	    	mode=255; backmode=2; 
	    	msg1="You can't make"; 
	    	msg2="move from region";
	    	msg3="that don't belong"; 
	    	msg4="to you.";
	    	//repaint(0,0,10,10);
	    } else {
		mapfrom=mappos; mode=3;
	    	//repaint(0,0,10,10);
	    }
	} else if (mode==3) {
	    if ((isConnected(mappos,mapfrom)==0)&&(!long_conn(mapfrom,mappos))) {
	    	mode=255; backmode=3; 
	    	msg1="You can't make"; 
	    	msg2="move to so far";
	    	msg3="region."; 
	    	msg4="";
	    	//repaint(0,0,10,10);
	    } else {
		mode=4; soldiers=army[mapfrom]-1;
	    }
	} else if (mode==4) {
	    move( mapfrom, mappos, soldiers);
	    mode=1; menupos=0;
	}  else if ((mode==6)&&(mpos==7)) {  /* MENU-BACK */
	    mode=1; mpos=0;  //repaint(0,0,0,0);
	} else if ((mode==6)&&(mpos==0)) {  /* MENU-NEW */
	    mode=0; mpos=0; start();//repaint(0,0,0,0);
	} else if (mode==255) {
	    mode=backmode; //repaint(0,0,10,10);
	} else if (mode==7) {
	    mode=1;
	} else if ((mode==8)||(mode==9)) {
	    mode=0; mpos=0; start(); 	    
	}

    }

    private int count_supplies( int player )
    {
	int i,count=0;
	
	for( i=0; i<REGIONS; i++) 
	    if (owner[i]==player+1) 
		count++;

	return count;
    }

    private void redraw_position(int pos)
    {
	Graphics Temp = map.getGraphics();

	for( int i=0; i<128*120; i++) {
	   if (maptx[i]-1==(char) pos) {
		if ( ( (i-128>0)&&(maptx[i-128]>0)&&(maptx[i-128]!=pos+1))  ||( (i-1  >0)&&(maptx[i-1]>0)&&(maptx[i-1]!=pos+1)) )
		Temp.setColor(0,0,0); else Temp.setColor( mapR[owner[pos]], mapG[owner[pos]], mapB[owner[pos]]);
		Temp.drawLine( i%128, i/128, i%128, i/128);
	   } 
	}
    }

    private int find_rand_move( int pos )
    {
	int i,j;
	Random R=new Random();
	j=R.nextInt()%5;
	if (j<5) j+=5;
	i=0;
	while (true) {
	    if (isConnected( pos, i)!=0) 
		if (j--==0)
		    break;	
	    i=(i+1)%REGIONS;
	}
	return i;
    }

    private int count_conn( int pos )
    {
	int i,cnt;
	
	cnt=0;
	for( i=0; i<all_conns; i++) {
	    if (conn1[i]==pos) cnt++;
	    if (conn2[i]==pos) cnt++;
	}

	return cnt;
    }

    private int find_conn( int pos, int nr)
    {
	int i,cnt;
	
	cnt=nr;
	for( i=0; i<all_conns; i++) {
	    if (conn1[i]==pos) 
		if (cnt--==0) 
		    return conn2[i];
	    if (conn2[i]==pos) 
		if (cnt--==0) 
		    return conn1[i];
	}

	return -1;
    }

    private boolean long_conn( int from, int to )
    {
	boolean colors[]=new boolean[REGIONS];
	int i, j;

	for( i=0; i<REGIONS; i++) 
	    colors[i]=false;

	colors[from]=true;
	
	j=1;
	while (j>0) {
	    j=0;
	    for( i=0; i<all_conns; i++) {
	        if ((colors[conn1[i]])&&(!colors[conn2[i]])&&(owner[conn2[i]]==owner[from])) {
		    if (conn2[i]==to)
			return true;
		    j++;
		    colors[conn2[i]]=true;
		    continue;
  	        }
	        if ((colors[conn2[i]])&&(!colors[conn1[i]])&&(owner[conn1[i]]==owner[from])) {
		    if (conn1[i]==to)
			return true;
		    j++;
		    colors[conn1[i]]=true;
		    continue;
		}
                if (conn1[i]==to) if (colors[conn2[i]]) return true;
                if (conn2[i]==to) if (colors[conn1[i]]) return true;
	    }
	}

	return false;
    }

    private void run_ai()
    {
	int i, j, k, from=0, to=0, armies, player,cnt=0;
	Random R=new Random();

        lost_soldiers=0;

	for( player=0; player<PLAYERS; player++) { //buggy shit
	    for( i=0; i<REGIONS; i++)
	        if (owner[i]==player+1) 
		    break;
	    if ((i==REGIONS)||(owner[i]!=player+1)) continue; /* dead player */
	    menupos=(char) player;
	    army[i]+=count_supplies(player);	   

	    if (army[i]>9) {
		j=army[i]-9; army[i]=9;
		redraw_position(i);
	        for( i=0; i<REGIONS; i++)
	            if ((owner[i]==player+1)&&(army[i]<10)) {
			army[i]+=j;
			if (army[i]<10) {
			    redraw_position(i); j=0;
			    break;
			}
			j=army[i]-9;
			army[i]=9;
		        redraw_position(i);
		    }
		if (player==0) lost_soldiers=j;
	    }  else redraw_position(i);


	    if (player==0) continue;
	    do {
		k=0;
	        for( i=0; i<all_conns; i++) { /* obligatory moves ;) */
		    j=0;
		    if (owner[conn1[i]]==player+1) { j++; from=conn1[i]; to=conn2[i]; }
		    if (owner[conn2[i]]==player+1) { j++; from=conn2[i]; to=conn1[i]; }
		    if (j!=1) continue;
		    if ((army[from]>2*army[to])&&(army[from]>1)) {
		        move( from, to, army[from]-1); k++;
		    }
	        }
		j=k;
	
	        for( i=0; i<REGIONS; i++)
		    if (owner[i]==player+1) 
		        j++;
                for( i=0; i<REGIONS; i++)
                    if ((owner[i]==player+1)&&(army[i]>1)) {
			if (count_conn(i)==1) { /* obligatory = evacuate backs */
			    to=find_conn(i,0);
			    if (owner[i]==player+1)
				move( i, to, army[i]-1);
			} else {
   	                    to=find_rand_move( i );
		            armies=R.nextInt()%(army[i]-1);
		            if (armies<0) armies+=army[i]-1;
		            if ((army[to]>=armies)&&(armies<8)) continue; /* never attack too strong army */
 		            move( i, to, armies);	
		            k++;
			}
	            }
	        for( i=0; i<REGIONS; i++)
	            if (owner[i]==player+1) 
	                j--;
		if (k==0) break;
	    } while (j>0);

	    //repaint(0,0,10,10);
	    cnt++;
	}
	if (cnt>0) { /* supplies arrived */
	    mode=7; 
	    soldiers=count_supplies(0);
	    draw_army(map);
	} else {
	    mode=8; /* YOU WIN */
	}
	for(i=0; i<REGIONS; i++) 
	    if ((rcenterx[i]>=0)&&(owner[i]==1)) {
	        mappos=(char) i; break;
	    }
        for( i=0; i<REGIONS; i++)
           if (owner[i]==1) 
	       return;
	mode=9; /* YOU LOOSE */
    }

    private void move( int from, int to, int howmany )
    {
	int win, i;
	Graphics Temp = map.getGraphics();
	
	if (howmany<=0) return;
	army[from]-=howmany;
	if (owner[to]==0) {
	    owner[to]=owner[from]; army[to]=howmany;
	} else {
	    if (owner[to]==owner[from]) { //basic transport
		army[to]+=howmany;
		if (army[to]>9) {
		    i=army[to]-9; /* too much armies */
		    army[to]-=i;
		    army[from]+=i;
		}
	    } else {
		if (army[to]<howmany) { // winning
		    army[to]=howmany-army[to];
		    owner[to]=owner[from];
		} else { //loosing
		    army[to]-=howmany;
		    if (army[to]==0) army[to]++;
		}
	    }
	}

	for( i=0; i<128*120; i++) {
	   if (maptx[i]-1==(char) from) {
		Temp.setColor( mapR[owner[from]], mapG[owner[from]], mapB[owner[from]]);
		if ( ( (i-128>0)&&(maptx[i-128]>0)&&(maptx[i-128]!=from+1))  ||( (i-1  >0)&&(maptx[i-1]>0)&&(maptx[i-1]!=from+1)) )
		Temp.setColor(0,0,0); else Temp.setColor( mapR[owner[from]], mapG[owner[from]], mapB[owner[from]]);
		Temp.drawLine( i%128, i/128, i%128, i/128);
	   } else if (maptx[i]-1==(char) to) {
		if ( ( (i-128>0)&&(maptx[i-128]>0)&&(maptx[i-128]!=to+1))  ||( (i-1  >0)&&(maptx[i-1]>0)&&(maptx[i-1]!=to+1)) )
		Temp.setColor(0,0,0); else Temp.setColor( mapR[owner[to]], mapG[owner[to]], mapB[owner[to]]);
		Temp.drawLine( i%128, i/128, i%128, i/128);
	   }
	}
	draw_army(map);
	//repaint(0,0,1,1);
	
    }

    int distance( int i, int j)
    {
	return (rcenterx[i]-rcenterx[j])*(rcenterx[i]-rcenterx[j])+(rcentery[i]-rcentery[j])*(rcentery[i]-rcentery[j]);
    }

    void selecter(int mx, int my)
    {
	int mp,bp=0,max,f;

        max=0;
        for( int i=0; i<all_conns; i++) {
    	    if (conn1[i]==mappos) mp=conn2[i]; else
	        if (conn2[i]==mappos) mp=conn1[i]; else
	            continue;
	    f=(rcentery[mp]-rcentery[mappos])*my+(rcenterx[mp]-rcenterx[mappos])*mx;
	    if (f>max) {
	        max=f;
	        bp=mp;
	    }
	}
	if (max>0) {
	    draw_selected_map( map, map2, bp);
	    mappos=(char) bp;
	    anicnt=0;
	    //repaint(0, 0, getWidth(), getHeight());
	}		
    }

    private void got_up()
    {
	if ((mode==2)||(mode==3)) { selecter(0,-1); }
        if (mode==4) { if (++soldiers>=army[mapfrom]) soldiers=(int) army[mapfrom]-1; }
	if (mode==6) { if (menupos<0) menupos=7; }
    }

    private void got_down()
    {
	if ((mode==2)||(mode==3)) { selecter(0,1); }
        if (mode==4) { if (--soldiers<0) soldiers=0;  }
	if (mode==6) { if (menupos>7) menupos=0; }
    }

    private void got_left()
    {
	if ((mode==2)||(mode==3)) { selecter(-1,0); }
        if (mode==4) { soldiers=0; /*repaint(0,0,1,1);*/ }
    }

    private void got_right()
    {
	if ((mode==2)||(mode==3)) { selecter(1,0); }
        if (mode==4) { soldiers=army[mapfrom]-1; /*repaint(0,0,1,1);*/ }
    }

   /*---------------------------------------------------------------------*/

    private int getNearestRegion( int x, int y)
    {
	int len=99999, best=0, temp;
	
	for (int i=0; i<REGIONS; i++) {
	    temp= (rcenterx[i]-x)*(rcenterx[i]-x) + (rcentery[i]-y)*(rcentery[i]-y);
	    if (temp<len) {
		best=i; len=temp;
	    }
	}

	return best;
    }

    private int getLenNR( int x, int y)
    {
	int i=getNearestRegion(x,y);
	
	return  (rcenterx[i]-x)*(rcenterx[i]-x) + (rcentery[i]-y)*(rcentery[i]-y);
    }

    public synchronized void init()
    {
        smallfont = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_SMALL);
        bigfont   = Font.getFont(Font.FACE_PROPORTIONAL,
                            Font.STYLE_PLAIN,
                            Font.SIZE_LARGE);

	rcenterx = new int[REGIONS];	rcentery = new int[REGIONS];   owner=new int[REGIONS]; continent=new int[REGIONS]; army=new int[REGIONS];
	conn1    = new int[CONNECTIONS];conn2    = new int[CONNECTIONS];
	maptx    = new char[128*120];

	map  = Image.createImage( 128, 120);
	map2 = Image.createImage( 128, 120);

        animationThread = new Thread(this);
        animationThread.start();
	mode =0;
//	repaint(0,0,1,1);
    } 

    public void start()
    {
	generate_map();
	draw_map (map);
	//repaint(0,0,0,0);
	draw_army(map); 
	mode=1;
	//repaint(0,0,0,0);
    }

    private void pelzacz( int x, int y)
    {
	char k;

	if ((x<0)||(x>127)||(y<0)||(y>119))
	    return;

	k=maptx[ y*128+x ];
	
	for( int i=x-1; i<=x+1; i++)
   	    for( int j=y-1; j<=y+1; j++) {
		if ((i>=0)&&(j>=0)&&(i<128)&&(j<120)) {
		    if  (maptx[j*128+i]==0) 
			maptx[ j*128+i ]=k;
		}
	}
    }

    public int isConnected( int i, int j)
    {
	for( int k=0; k<all_conns; k++)
	    if ( ((conn1[k]==i)&&(conn2[k]==j)) || ((conn1[k]==j)&&(conn2[k]==i)) ) 
		return 1;

	return 0;
    }

    public void generate_map()
    {
	int x,y,x2,y2,i,j,l,k, maxlen, minlen, ct,ct2;
	Random R=new Random();
	Graphics Temp;

	Temp = map.getGraphics();



	for( i=0; i<32; i++) {
	    for( j=0; j<32; j++) {
		Temp.setColor( 8*i, 8*j, 255);
		Temp.fillRect( 4*i, 4*j, 4*i+3, 4*j+3);
	    }
	}

        j=0;
	Temp.setColor( 0, 0, 0);
	Temp.drawString( " Generating map...", 5,50,0);
	Temp.setColor( 64, 64, 128);
	Temp.drawString( " Generating map...", 6,51,0);
	Temp.setColor( 64,64,64);
	Temp.drawRect( 10,90, 108, 7 );

	for( i=0; i<128*120; i++) maptx[i]=0;

	for( i=0; i<564; i++) {
	    x= (R.nextInt()%110)+9; y= (R.nextInt()%100)+9; 
	    if ((getLenNR(x,y)<100)||(x<9)||(y<9)) continue;
	    rcenterx[j]=x; rcentery[j++]=y;
	    maptx[ y*128+x ] = (char) j;
	    if (j==REGIONS) break;
	}
        k=0;
	
	maxlen=0;
	for( i=0; i<REGIONS; i++) {
	    minlen=999999;
	    for( j=0; j<REGIONS; j++) {
	        l = (rcenterx[i]-rcenterx[j])*(rcenterx[i]-rcenterx[j]) + (rcentery[i]-rcentery[j])*(rcentery[i]-rcentery[j]);
		if ( (i!=j) && (minlen>l) ) minlen=l;
	    }
	    if (minlen>maxlen) maxlen=minlen;
	}

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 20,4);  //repaint(0, 0, getWidth(), getHeight());

	for( i=0; i<128*12; i++) { // terrain grow...
	    x=i%128; y=i/128;
	    pelzacz( x, y);
	    if ( maptx[i]>0 ) i++;
	}

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 40,4);  //repaint(0, 0, getWidth(), getHeight());
	for( i=0; i<95535; i++) { // terrain grow...
	    x= (R.nextInt()%110)+9; y= (R.nextInt()%100)+9; 
	    pelzacz( x, y);
	}

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 60,4);  //repaint(0, 0, getWidth(), getHeight());
	for( i=0; i<REGIONS; i++){ //delete small countries
	    l=0;
 	    for( j=0; j<128*120 ; j++) {
		if ( maptx[j] == (char) i+1 ) l++;
	    }	    
	    if (l<MINIMAL_COUNTRY_SIZE) { // yeah. delete it.
		rcenterx[i]=-1;
 	        for( j=0; j<128*120 ; j++)  
		    if ( maptx[j] == (char) i+1 ) maptx[j]=0;		
	    }
	}
	

	all_conns=0;

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 80,4); // repaint(0, 0, getWidth(), getHeight());
	for( i=0; i<128*120 ; i++) { //draw map, do connections
	    k=maptx[ i ];
	    if (k==0) {
	        Temp.setColor( 0, 0, 255 );
	    } else {
		l=0; 
		if ( (i-128>0)&&(maptx[i-128]>0)&&(maptx[i-128]!=k)) l=maptx[i-128];
		if ( (i-1  >0)&&(maptx[i-1]>0)&&(maptx[i-1]!=k)) l=maptx[i-128];
		if (l==0) {
		//    Temp.setColor( 64, 64, 64);
		} else {
		    if (isConnected(k-1,l-1)==0) {
			conn1[all_conns  ]=k-1;	
			conn2[all_conns++]=l-1;
		    }
		    if (all_conns>CONNECTIONS) {
			generate_map();
			return;
		    }
		    //Temp.setColor( 0, 0, 0);
		}
	    }	    
//	    Temp.drawLine( i%128, i/128, i%128, i/128);
	}

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 85,4);  //repaint(0, 0, getWidth(), getHeight());
	for( i=0; i<REGIONS; i++) 
	    if (rcenterx[i]>=0) {
		owner[i]=i;
	    }
	for( i=0; i<all_conns; i++) {
	    j=conn1[i]; k=conn2[i];	    
	    j=owner[j]; k=owner[j];
	    for( l=0; l<REGIONS; l++) 
		if (owner[l]==j) owner[l]=k;
	}

        for( l=0; l<REGIONS; l++) 
	    continent[l]=owner[l];

	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 95,4);  //repaint(0, 0, getWidth(), getHeight());
        while (true) {

	    maxlen=0; minlen=9999;

  	    for( i=0; i<REGIONS; i++)
	        if (rcenterx[i]>=0) {
		    if (owner[i]>maxlen) maxlen=owner[i];
		    if (owner[i]<minlen) minlen=owner[i];
	        }

	    if (maxlen==minlen) break;

	    ct=ct2=x=y=x2=y2=99999;

  	    for( i=0; i<REGIONS; i++)
	        if ((rcenterx[i]>=0)&&(owner[i]==minlen)) {
  	    	    for( j=0; j<REGIONS; j++)
	        	if ((rcenterx[j]>=0)&&(owner[j]!=minlen)) {
			    l= (rcenterx[j]-rcenterx[i])*(rcenterx[j]-rcenterx[i])+(rcentery[j]-rcentery[i])*(rcentery[j]-rcentery[i]);
			    if (l<ct) {
				x2=x;y2=y;ct2=ct;
				x=i; y=j; ct=l;
			    } else if (l<ct2) {
				x2=i; y2=j; ct2=l;
			    }
			}
		}
   
   	    conn1[all_conns  ]=x; x=owner[x];
	    conn2[all_conns++]=y; y=owner[y];

	    for( l=0; l<REGIONS; l++) 
		if (owner[l]==x) owner[l]=y;

	    if ((y2<99999)&&(owner[y2]!=y)) {
   	    	conn1[all_conns  ]=x2; x=owner[x2];
	    	conn2[all_conns++]=y2; y=owner[y2];

	    	for( l=0; l<REGIONS; l++) 
		    if (owner[l]==x2) owner[l]=y2;
	    }

 	}
	
	Temp.setColor( 0, 0,255);  Temp.fillRect(12,92, 105,4);  //repaint(0, 0, getWidth(), getHeight());

	for( i=0; i<all_conns; i++) {
	    j=conn1[i]; k=conn2[i];                                                                    	
	    Temp.setColor(255,0,0);
	    Temp.drawLine( rcenterx[j], rcentery[j], rcenterx[k], rcentery[k]);
	}

        Temp.setColor(255,255,0);

	j=0;
	for( i=0; i<REGIONS; i++) {
    	    owner[i]=0;
	    army[i]=0;
	    if ((rcenterx[i]>=0)&&(j<PLAYERS)) {
		owner[i]=++j;
		army[i]=STARTING_ARMY;
	    }
	}

	for(i=0; i<REGIONS; i++) 
	    if ((rcenterx[i]>=0)&&(owner[i]==1)) {
	        mappos=(char) i; break;
	    }

    }


    private void draw_map( Image myMap )
    {
	Graphics Temp;
	int i,j,k,l;
	Random R=new Random();

	Temp = myMap.getGraphics();

        Temp.setColor(0,0,255);
	Temp.fillRect(0,0,127,120);

	k=0;
/*	for( i=0; i<128*120; i++) {
	    j=R.nextInt()%16;
	    k+=j;
	    if (k<0) k=0;
	    if (k>128) k=128;
	    Temp.setColor( k,k,255);
	    Temp.drawLine( i%128, i/128, i%128, i/128);
	}*/

	for( i=0; i<all_conns; i++) {
	    j=conn1[i]; k=conn2[i];
	    Temp.setColor(0,0,0);
	    Temp.drawLine( rcenterx[j], rcentery[j], rcenterx[k], rcentery[k]);
	}

        Temp.setColor(0,0,255);

	for( i=0; i<128*120 ; i++) { //draw map, do connections
	    k=maptx[ i ];
	    if (k==0) {
	        continue;
	    } else {
		l=0; 
		if ( (i-128>0)&&(maptx[i-128]>0)&&(maptx[i-128]!=k)) l=maptx[i-128];
		if ( (i-1  >0)&&(maptx[i-1]>0)&&(maptx[i-1]!=k)) l=maptx[i-128];
		if (l==0) {		    
		    Temp.setColor( 64, 64, 64);
		    if (owner[k-1]>0) {
			Temp.setColor( mapR[owner[k-1]], mapG[owner[k-1]], mapB[owner[k-1]]);
		    }
		} else {
		    Temp.setColor( 0, 0, 0);
		}
	    }	    
	    Temp.drawLine( i%128, i/128, i%128, i/128);
	}
    }

    private void draw_selected_map(Image fromMap, Image toMap, int pos)
    {
	Graphics Temp = toMap.getGraphics();

	Temp.setColor(255,255,255);
	Temp.drawImage(fromMap,0,0,0);
	
	pos++;
	for( int i=0; i<128*120; i++) {
	   if (maptx[i]==pos) {
		Temp.drawLine( i%128, i/128, i%128, i/128);
	   }
	}

    }

    private void draw_army(Image myMap)
    {
	int i; 
	Graphics Temp = myMap.getGraphics();
	
	Temp.setFont(smallfont);

	for( i=0; i<REGIONS; i++)
	    if (owner[i]>0) {
		Temp.drawString( String.valueOf(army[i]), rcenterx[i]-4, rcentery[i]-4, 0);
	    }
    }

    public void run()
    {
        Thread currentThread = Thread.currentThread();

        try
        {
            // This ends when animationThread is set to null, or when
            // it is subsequently set to a new thread; either way, the
            // current thread should terminate
            while (currentThread == animationThread)
            {
                long startTime = System.currentTimeMillis();
                //tickBoids();
//		if ((mode==2)||(mode==3)) {
                    repaint(0, 0, getWidth(), getHeight());
//		}
                serviceRepaints();
                long timeTaken = System.currentTimeMillis() - startTime;
                if (timeTaken < MILLIS_PER_TICK)
                {
                    synchronized (this)
                    {
                        wait(MILLIS_PER_TICK - timeTaken);
                    }
                }
                else
                {
                    currentThread.yield();
                }
            }
        }
        catch (InterruptedException e)
        {
        }
    }

    public void keyPressed(int keyCode)
    {
	if ((keyCode==-1)||(keyCode=='2')) {
	    menupos--;
	    got_up();
	} else if ((keyCode==-2)||(keyCode=='8')) {
	    menupos++;
	    got_down();
	} else if ((keyCode==-3)||(keyCode=='4')) {
	    got_left();
	} else if ((keyCode==-4)||(keyCode=='6')) {
	    got_right();

	} else if ((keyCode==-10)||(keyCode=='5')) {
	    got_enter(menupos);
	}
    }

    public void commandAction(Command c, Displayable d)
    { //have to be with keyPressed.
    }
}